=== modified file 'drizzled/function/time/date_add_interval.cc'
--- drizzled/function/time/date_add_interval.cc	2009-02-28 17:49:22 +0000
+++ drizzled/function/time/date_add_interval.cc	2009-02-28 17:49:44 +0000
@@ -91,7 +91,6 @@
   return 0;
 }
 
-
 String *Item_date_add_interval::val_str(String *str)
 {
   assert(fixed == 1);
@@ -104,7 +103,9 @@
     make_date(&ltime, str);
   else if (ltime.second_part)
   {
-    uint32_t length= sprintf(str->c_ptr(), "%04u-%02u-%02u %02u:%02u:%02u.%06u",
+    /* Ensure we've got enough room for our timestamp string. */
+    str->length(MAX_DATETIME_FULL_WIDTH);
+    size_t length= sprintf(str->c_ptr(), "%04u-%02u-%02u %02u:%02u:%02u.%06u",
                           ltime.year,
                           ltime.month,
                           ltime.day,
@@ -121,7 +122,6 @@
   return str;
 }
 
-
 int64_t Item_date_add_interval::val_int()
 {
   assert(fixed == 1);

